#!/usr/bin/env ruby

## 2016-08-04

## - Shuffle each cols (except ID) between k records
##   - Records are grouped by sorting [M[*,1], M[*,3]]
## - Randomize T

M_CID = 0
M_SEX = 1
M_BIRTHDAY = 2
M_COUNTRY = 3
M_SIZE = 4

T_CID = 0
T_INVOICE = 1
T_DATE = 2
T_TIME = 3
T_IID = 4
T_PRICE = 5
T_QUANTITY = 6
T_SIZE = 7

def read_table(f = $stdin)
  n = f.gets.chomp.to_i
  (0...n).map{f.gets.chomp}
end

def read_table_skip(f = $stdin)
  n = f.gets.chomp.to_i
  n.times{f.gets}
end

def write_table(t, f = $stdout, no_line_num = false)
  f.puts t.size unless no_line_num
  f.puts t
end

def read_p(f = $stdin)
  read_table(f).map{|x| x.to_i - 1}
end

def write_p(p, f = $stdout, no_line_num = false)
  write_table(p.map{|x| x + 1}, f, no_line_num)
end

## res[i] = a[p[i]]
def unapply(a, p)
  p.map{|i| a[i]}
end

def shuffle(a)
  a.sort_by{rand}
end

def rand_perm(n)
  shuffle((0...n).to_a)
end



=begin
def ano_rename0(m, t)
  n = m.size
  y = rand_perm(n).map{|x| x.to_s}
  k2y = Hash.new
  m2 = []
  m.each do |s|
    a = s.split(/,/)
    k = a[0]
    k2y[k] = y[k2y.size] unless k2y[k]
    a[0] = k2y[k]
    m2 << a.join(',')
  end
  t2 = []
  t.each do |s|
    a = s.split(/,/)
    a[0] = k2y[a[0]]
    t2 << a.join(',')
  end
  return [m2, t2]
end
=end

def ano_rename(m, t)
  k = m.map{|s| s.split(/,/)[0]}.sort.uniq
  h = Hash[k.zip(shuffle(1..k.size))]
  [m, t].map{|x| x.map{|s| a = s.split(/,/); a[0] = h[a[0]]; a.join(",")}}
end

def ano_out(m0, t0, p)
  m, t = ano_rename(m0, t0)
  q = rand_perm(m.size)
  write_table(unapply(m, q))
  write_table(shuffle(t))
  write_p(unapply(p, q))
end

def read_int(dval)
  x = ARGV.shift
  x ? x.to_i : dval
end

def read_float(dval)
  x = ARGV.shift
  x ? x.to_f : dval
end

def read_array(a, dval)
  return dval unless n = a.shift
  (0...n.to_i).map{a.shift.to_i}
end



def max(x, y)
  x > y ? x : y
end

def min(x, y)
  x > y ? y : x
end

def abs(x)
  x < 0 ? -x : x
end

def rand_t(t)
  def rename_ary(a)
    h = Hash.new
    shuffle(a.sort.uniq).each{|k| h[k] = h.size + 1}
    a.map{|k| h[k]}
  end
  
  def rand_range(r0, r1)
    r0 + rand * (r1 - r0)
  end
  
  n = t.size
  t = t.map{|x| x.split(/,/)}.transpose
  t[T_INVOICE] = rename_ary(t[T_INVOICE])
  t[T_TIME] = (0...n).map{"10:10"}
  t[T_IID] = (0...n).map{"1234"}
  p = 0.05
  t[T_PRICE] = t[T_PRICE].map{|x| sprintf("%.2f", max(x.to_f * rand_range(1.0 - p, 1.0 + p), 0.01))}
  t[T_QUANTITY] = t[T_QUANTITY].map{|x| 1 + rand(x.to_i * 2 - 1)}
  return t.transpose.map{|a| a.join(",")}
end

## Group by [m[1], m[3]], then independently swap m[1], m[2] and m[3]
def sw2(m, k = 2)
  n = m.size
  ids = [m.map{|x| a = x.split(/,/); a[M_SEX] + a[M_COUNTRY]}, (0...n).map{rand}, (0...n).to_a].transpose.sort.transpose[2]
  gs = []
  0.step(n-1, k){|i| gs << ids[i, k]}
  r = n % k
  gs[-1] += ids[-r, r] unless r == 0
  m2 = Array.new(n)
  gs.each do |g|
    a = g.map{|i| m[i].split(/,/)}.transpose
    a[M_SEX..-1] = a[M_SEX..-1].map{|x| shuffle(x)}
    b = a.transpose
    g.each_with_index do |i, j|
      m2[i] = b[j].join(",")
    end
  end
  return m2
end

## input (M, T)
m = read_table()
t = read_table()

## body
k = read_int(2)
n = m.size
m = sw2(m, k)
t = rand_t(t)
p = (0...n).to_a

## output (M', T', P)
ano_out(m, t, p)
