#!/usr/bin/env ruby

## 2016-08-04

## - Yamaoka anonymization: randomly permute the rows of M

def read_table(f = $stdin)
  n = f.gets.chomp.to_i
  (0...n).map{f.gets.chomp}
end

def read_table_skip(f = $stdin)
  n = f.gets.chomp.to_i
  n.times{f.gets}
end

def write_table(t, f = $stdout, no_line_num = false)
  f.puts t.size unless no_line_num
  f.puts t
end

def read_p(f = $stdin)
  read_table(f).map{|x| x.to_i - 1}
end

def write_p(p, f = $stdout, no_line_num = false)
  write_table(p.map{|x| x + 1}, f, no_line_num)
end

## res[i] = a[p[i]]
def unapply(a, p)
  p.map{|i| a[i]}
end

def shuffle(a)
  a.sort_by{rand}
end

def rand_perm(n)
  shuffle((0...n).to_a)
end



=begin
def ano_rename0(m, t)
  n = m.size
  y = rand_perm(n).map{|x| x.to_s}
  k2y = Hash.new
  m2 = []
  m.each do |s|
    a = s.split(/,/)
    k = a[0]
    k2y[k] = y[k2y.size] unless k2y[k]
    a[0] = k2y[k]
    m2 << a.join(',')
  end
  t2 = []
  t.each do |s|
    a = s.split(/,/)
    a[0] = k2y[a[0]]
    t2 << a.join(',')
  end
  return [m2, t2]
end
=end

def ano_rename(m, t)
  k = m.map{|s| s.split(/,/)[0]}.sort.uniq
  h = Hash[k.zip(shuffle(1..k.size))]
  [m, t].map{|x| x.map{|s| a = s.split(/,/); a[0] = h[a[0]]; a.join(",")}}
end

def ano_out(m0, t0, p)
  m, t = ano_rename(m0, t0)
  q = rand_perm(m.size)
  write_table(unapply(m, q))
  write_table(shuffle(t))
  write_p(unapply(p, q))
end

## input (M, T)
m = read_table()
t = read_table()

## body
p = rand_perm(m.size)

## output (M', T', P)
ano_out(m, t, p)
