#!/usr/bin/env ruby

## 2016-08-04

## - Search by total amount of money

M_CID = 0
M_SEX = 1
M_BIRTHDAY = 2
M_COUNTRY = 3
M_SIZE = 4

T_CID = 0
T_INVOICE = 1
T_DATE = 2
T_TIME = 3
T_IID = 4
T_PRICE = 5
T_QUANTITY = 6
T_SIZE = 7

def read_table(f = $stdin)
  n = f.gets.chomp.to_i
  (0...n).map{f.gets.chomp}
end

def read_table_skip(f = $stdin)
  n = f.gets.chomp.to_i
  n.times{f.gets}
end

def write_table(t, f = $stdout, no_line_num = false)
  f.puts t.size unless no_line_num
  f.puts t
end

def read_p(f = $stdin)
  read_table(f).map{|x| x.to_i - 1}
end

def write_p(p, f = $stdout, no_line_num = false)
  write_table(p.map{|x| x + 1}, f, no_line_num)
end

## res[i] = a[p[i]]
def unapply(a, p)
  p.map{|i| a[i]}
end

def shuffle(a)
  a.sort_by{rand}
end

def rand_perm(n)
  shuffle((0...n).to_a)
end

def money(m, t)
  n = m.size
  h = Hash[m.map{|x| x.split(/,/)[M_CID]}.zip((0...n).to_a)]
  h.default = nil
  res = Array.new(n){0.0}
  t.each do |x|
    a = x.split(/,/)
    k = a[T_CID]
    res[h[k]] += a[T_PRICE].to_f * a[T_QUANTITY].to_i if h[k]
  end
  return res
end

# 'ary' must be sorted
def find_nearest(ary, v)
  n = ary.size
  return 0 if n <= 0
  return 0 if v <= ary[0]
  return n-1 if ary[-1] <= v
  b = 0
  e = n-1
  while e - b >= 2
    m = (b + e) / 2
    if v < ary[m]
      e = m
    else
      b = m
    end
  end
  v - ary[b] > ary[e] - v ? e : b
end

def find_nearest_ary(ary, vs)
  n = ary.size
  a, id = ary.zip((0...n).to_a).sort.transpose
  vs.map{|v| id[find_nearest(a, v)]}
end

## input (M, T, M', T')
m = read_table()
t = read_table()
m2 = read_table()
t2 = read_table()

## body
q = find_nearest_ary(money(m, t),
                     money(m2, t2))

## output (Q)
write_p(q)
