#!/usr/bin/env ruby

## 2016-08-04

## - Sorting-based match by #transactions

def read_table(f = $stdin)
  n = f.gets.chomp.to_i
  (0...n).map{f.gets.chomp}
end

def read_table_skip(f = $stdin)
  n = f.gets.chomp.to_i
  n.times{f.gets}
end

def write_table(t, f = $stdout, no_line_num = false)
  f.puts t.size unless no_line_num
  f.puts t
end

def read_p(f = $stdin)
  read_table(f).map{|x| x.to_i - 1}
end

def write_p(p, f = $stdout, no_line_num = false)
  write_table(p.map{|x| x + 1}, f, no_line_num)
end

# |x| >= |y|
def match_by_sort(x, y)
  def sort_by(a, key)
    key.zip(a).sort.transpose[1]
  end
  m = x.size
  n = y.size
  #p = x.zip((0...m).to_a).sort.transpose[1]
  #q = y.zip((0...n).to_a).sort.transpose[1]
  #q.zip((0...n).map{|i| p[i * m / n]}).sort.transpose[1]
  p = sort_by((0...m).to_a, x)
  q = sort_by((0...n).to_a, y)
  sort_by((0...n).map{|i| p[i * m / n]}, q)
end

def match_exactly_or_rand(ary, keys)
  h = Hash.new
  ary.each_with_index do |k,i|
    h[k] = [] unless h[k]
    h[k] << i
  end
  n = ary.size
  keys.map{|k| h[k] ? h[k][rand(h[k].size)] : rand(n)}
end

def num_tr(m, t)
  n = m.size
  mkeys = m.map{|x| x.split(/,/)[0]}
  h = Hash[mkeys.zip((0...n).to_a)]
  h.default = nil
  ct = Array.new(n){0}
  t.each do |x|
    k = x.split(/,/)[0]
    ct[h[k]] += 1 if h[k]
  end
  return ct
end

## input (M, T, M', T')
m = read_table()
t = read_table()
m2 = read_table()
t2 = read_table()

## body
q = match_by_sort(num_tr(m,  t ),
                  num_tr(m2, t2))

## output (Q)
write_p(q)
