#!/usr/bin/env ruby

## 2016-08-16

require 'date'

def read_int(dval)
  x = ARGV.shift
  x ? x.to_i : dval
end

def read_float(dval)
  x = ARGV.shift
  x ? x.to_f : dval
end

def read_array(a, dval)
  return dval unless n = a.shift
  (0...n.to_i).map{a.shift.to_i}
end

M_CID = 0
M_SEX = 1
M_BIRTHDAY = 2
M_COUNTRY = 3
M_SIZE = 4

T_CID = 0
T_INVOICE = 1
T_DATE = 2
T_TIME = 3
T_IID = 4
T_PRICE = 5
T_QUANTITY = 6
T_SIZE = 7

def read_table(f = $stdin)
  n = f.gets.chomp.to_i
  (0...n).map{f.gets.chomp}
end

def read_table_skip(f = $stdin)
  n = f.gets.chomp.to_i
  n.times{f.gets}
end

def read_table_a(f = $stdin)
  read_table(f).map{|x|x.split(/,/)}
end

def write_table(t, f = $stdout, no_line_num = false)
  f.puts t.size unless no_line_num
  f.puts t
end

def read_p(f = $stdin)
  read_table(f).map{|x| x.to_i - 1}
end

def write_p(p, f = $stdout, no_line_num = false)
  write_table(p.map{|x| x + 1}, f, no_line_num)
end

## res[i] = a[p[i]]
def unapply(a, p)
  p.map{|i| a[i]}
end

def shuffle(a)
  a.sort_by{rand}
end

def rand_perm(n)
  shuffle((0...n).to_a)
end

def max(x, y)
  x > y ? x : y
end

def min(x, y)
  x > y ? y : x
end

def abs(x)
  x < 0 ? -x : x
end

def sum(a)
  a.inject(0){|x, y| x + y}
end

def mean(a)
  return 0 if a.empty?
  return sum(a).to_f / a.size
end

def abs(x)
  x < 0 ? -x : x
end

def mae(a, b, value_for_half_missing = 1e10)
  n = a.size
  mean((0...n).map{|i| (a[i] == b[i]) ? 0 : (a[i]!=nil && b[i]!=nil ? abs(a[i] - b[i]) : value_for_half_missing)})
end

def subset_diff_worst(m, m2, t, t2, p, d0, d1, num_c, drange)
  def mk_d2i_i2d(d0, d1)
    d2i = Hash.new
    i2d = []
    (d0-1).upto(d1) do |d|
      k = [d.year, d.month, d.day]
      d2i[k] = i2d.size
      i2d << k
    end
    return [d2i, i2d]
  end

  def prefix_sum(m, t, d2i, i2d)
    k2i = Hash.new
    m.each_with_index{|a, i| k2i[a[M_CID]] = i}
    d = i2d.size
    s = m.map{Array.new(d){0.0}}
    t.each do |a|
      i = k2i[a[T_CID]]
      next unless i
      k = a[T_DATE].split(/\//).map{|x| x.to_i}
      j = d2i[k]
      s[i][j] += a[T_PRICE].to_f * a[T_QUANTITY].to_i
    end
    s.each{|a| (d-1).times{|j| a[j+1] += a[j]}}
    return s
  end

  m = unapply(m, p)
  d2i, i2d = mk_d2i_i2d(d0, d1) # including d0-1, which is used as a guard
  s = prefix_sum(m, t, d2i, i2d)
  s2 = prefix_sum(m2, t2, d2i, i2d)
  d = d2i.size - 1
  res = 0.0
  0.upto(d - drange) do |j0|
    j1 = j0 + drange
    h1 = s.map{|a| a[j1] - a[j0]}
    h2 = s2.map{|a| a[j1] - a[j0]}
    x = h1.zip(h2).map{|a| a[1] - a[0]}.sort
    res = max(res,
              min(abs(mean(x[0, num_c])),
                  abs(mean(x.reverse[0, num_c]))))
  end
  return res
end

## input (M, T, M', T', P)
m = read_table_a()
t = read_table_a()
m2 = read_table_a()
t2 = read_table_a()
p = read_p()

## body
num_c = read_int(10)
date_range = read_int(30)
d0 = Date.new(2010, 12, 1)
d1 = Date.new(2011, 12, 9)
e = subset_diff_worst(m, m2, t, t2, p, d0, d1, num_c, date_range)
e = [e]

## output
write_table(e)
