#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

require '/home/ruby_ap/2016/ut-apdata_v0.1'

def read_table(f = $stdin)
  n = f.gets.chomp.to_i
  (0...n).map{f.gets.chomp}
end

def write_table(t, f = $stdout, no_line_num = false)
  f.puts t.size unless no_line_num
  f.puts t
end

def form2ht(t)
  ret_ht = Hash.new
  t.map{|x|x.split(/,/)}.each do |x|
    ret_ht[x[1]] = [] unless ret_ht[x[1]] 
    ret_ht[x[1]] << x[4]
  end
  return ret_ht
end

def subset?(set1, set2)
  return (set2 - set1).empty?
end

def count_top_items(trans, items)
  count_array = Array.new(items.length, 0)
  trans.each{|key, set|
    for i in 0...items.length do
      count_array[i] += 1 if subset?(set, items[i])
    end
  }
  return count_array
end

# This part should be removed before PWSCUP2016
def extract_top_items(fingerprint)
  case fingerprint
  when 8695
    return $f100_content, $f100_sup, $f100_sum
  when 38087 
    return $f400_content, $f400_sup, $f400_sum
  when 397625 
    return $f_content, $f_sup, $f_sum
  else
    return false
  end
end

def score(count_list, threshold, summation)
  sum = 0
  t = threshold * summation
  count_list.each{|x| sum+=1 if x > t}
  return sum.to_f/count_list.size.to_f
end

read_table()        
top_items, threshold, summation =  extract_top_items(read_table().size)
unless top_items
  puts("Non-supported Transaction data.")
  exit(1)
end
read_table()        
write_table([score(count_top_items(form2ht(read_table()), top_items), 
                   threshold, 
                   summation)
            ])
